///////////////////////////////////
//
//   Add-On: Overlap Building
//
//   ---------------------------
//
//   Author: General
//   BL ID: 4878
//
//   ---------------------------
//
//   File: server.cs
//
//   File version: 1
//   Last updated on: 13/03/2012
//
///////////////////////////////////



package OverlapBuildingBASE
{
	function serverCmdToggleOB(%client)
	{
		if(%client.isLocalConnection() || %client.bl_id == getNumKeyID())
		{
			for(%i=0;%i<getNumActivePackages();%i++)
				if(getActivePackage(%i) $= "OverlapBuilding")
					%a=1;
					
			if(%a)
			{
				deactivatePackage("OverlapBuilding");
				announce("Overlap Building \c0is now disabled");
			}
			else
			{
				activatePackage("OverlapBuilding");
				announce("Overlap Building \c0is now enabled");
			}
		}
	}
};
activatePackage("OverlapBuildingBASE");

package OverlapBuilding
{
	function serverCmdPlantBrick(%client)
	{
		%pb = %client.brickGroup.getObject(%client.brickGroup.getCount() - 1);
		parent::serverCmdPlantBrick(%client);
		%pb2 = %client.brickGroup.getObject(%client.brickGroup.getCount() - 1);
		if(%pb == %pb2)
			OB_Plant(%client);
	}
	
	function OB_Plant(%client)
	{
		%b=%client.player.tempBrick;
		%brick = new fxDTSBrick()
		{
			position = %b.position;
			rotation = %b.rotation;
			scale = %b.scale;
			dataBlock = %b.dataBlock;
			angleID = %b.angleID;
			colorID = %b.colorID;
			printID = %b.printID;
			colorFxID = %b.colorFxID;
			shapeFxID = %b.shapeFxID;
			isBasePlate = %isBasePlate;
			isPlanted = "1";
			client = %client;
			stackBL_ID = %b.stackBL_ID;
		};
		%client.brickGroup.add(%brick);
		%brick.setTrusted(1);
		%err = %brick.plant();
		if(%err != 1)
		{
			%brick.delete();
			return;
		}
		%client.UndoStack.Push(%brick TAB "PLANT");
	}
};